diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/com/get_archive_args v15.6301-amd64/pop/com/get_archive_args
--- pp0/v15.61-amd64/pop/com/get_archive_args	2005-03-11 05:30:38.000000000 -0500
+++ v15.6301-amd64/pop/com/get_archive_args	2010-01-03 04:06:09.000000000 -0500
@@ -137,7 +137,10 @@
 # Output commands to set variables in caller shell -- this must be
 # eval'ed by the caller. AR and RANLIB must then be eval'ed after
 # setting LIBNAME.
-if [ $Shell = "csh" ]; then
+
+if [ "$Shell" == "csh" ]; then
+	echo "set CC='$CC'; set IDIRS='$IDIRS'; set CFLAGS='$CFLAGS'; set LIBEXTN='$LIBEXTN'; set AR='$AR'; set LDLIBS='$LDLIBS'; set RANLIB='$RANLIB'"
+elif [ "$Shell" == "tcsh" ]; then
 	echo "set CC='$CC'; set IDIRS='$IDIRS'; set CFLAGS='$CFLAGS'; set LIBEXTN='$LIBEXTN'; set AR='$AR'; set LDLIBS='$LDLIBS'; set RANLIB='$RANLIB'"
 else
 	echo "CC='$CC'; IDIRS='$IDIRS'; CFLAGS='$CFLAGS'; LIBEXTN='$LIBEXTN'; AR='$AR'; LDLIBS='$LDLIBS'; RANLIB='$RANLIB'"
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/extern/lib/c_core.c v15.6301-amd64/pop/extern/lib/c_core.c
--- pp0/v15.61-amd64/pop/extern/lib/c_core.c	2005-03-11 05:30:38.000000000 -0500
+++ v15.6301-amd64/pop/extern/lib/c_core.c	2010-01-03 00:30:40.000000000 -0500
@@ -1,7 +1,10 @@
-/* --- Copyright University of Sussex 1999. All rights reserved. ----------
+/* --- Copyright University of Sussex, University of Birmingham 2008. All rights reserved. ----------
  * File:			C.all/extern/lib/c_core.c
  * Purpose:			C routines for core POPLOG system
  * Author:			John Gibson, Aug 14 1987 (see revisions)
+ * Modified by Waldek Hebisch for new version of GCC, April 2006
+ * Modified by Waldek Hebisch to include linux_setper, 2 Dec 2008
+ * http://www.math.uni.wroc.pl/~hebisch/poplog/c_core.c
  */
 
 #include "c_core.h"
@@ -605,10 +608,16 @@
 #define REG_nPC nPC
 #endif
 
-/* #if defined(REG_RIP) */
-#define REG_PC REG_RIP
-/* #endif */
 
+#if defined(__linux__)
+#if defined(__x86_64__)
+#define REG_PC REG_RIP
+#else
+#if defined(__i386__)
+#define REG_PC REG_EIP
+#endif
+#endif
+#else
 #if defined(i386)
 #if defined(R_EIP)
 #define REG_PC R_EIP
@@ -616,6 +625,8 @@
 #define REG_PC EIP
 #endif
 #endif
+#endif
+
 
 void _pop_errsig_handler(int sig, siginfo_t *info, ucontext_t *context)
 {
@@ -2070,7 +2081,7 @@
 		int i;
                 tmp[0] = first_arg;
 		for (i = 1; i < MAX_N_ARGS; i++) tmp[i] = va_arg(argp,OPAQUE);
-#else 
+#else
 tmp[0] = arg0;
 tmp[1] = arg1;
 tmp[2] = arg2;
@@ -2104,8 +2115,111 @@
 	va_end(argp);
 	}
 
+#if defined(linux)
 
+/* Personality code, stolen from sbcl */
+
+/* Prototype for personality(2). Done inline here since the header file
+ *  * for this isn't available on old versions of glibc. */
+int personality (unsigned long);
+
+#include <sys/utsname.h>
+
+void
+linux_setper(int argc, char * * argv, char * * envp)
+{
+#if defined(__i386__) || defined(__x86_64__)
+    struct utsname name;
+    int major_version = 2;
+    int minor_version = 6;
+    int patch_version = 12;
+    char *p;
+    uname(&name);
+    p = name.release;
+    major_version = atoi(p);
+    p = strchr(p,'.')+1;
+    minor_version = atoi(p);
+    p = strchr(p,'.')+1;
+    patch_version = atoi(p);
+
+    if ((major_version == 2
+         /* Some old kernels will apparently lose unsupported personality
+            flags on exec() */
+         && ((minor_version == 6 && patch_version >= 11)
+             || (minor_version > 6)))
+        || major_version >= 3) {
+        int pers = personality(0xffffffffUL);
+        /* 0x40000 aka. ADDR_NO_RANDOMIZE */
+        if (!(pers & 0x40000)) {
+            int retval = personality(pers | 0x40000);
+            /* Allegedly some Linux kernels (the reported case was
+               "hardened Linux 2.6.7") won't set the new personality,
+               but nor will they return -1 for an error. So as a
+               workaround query the new personality...  */
+            int newpers = personality(0xffffffffUL);
+            /* ... and don't re-execute if either the setting resulted
+               in an error or if the value didn't change. Otherwise
+               this might result in an infinite loop. */
+            if (retval != -1 && newpers != pers) {
+                /* Use /proc/self/exe instead of trying to figure out
+                   the executable path from PATH and argv[0], since
+                   that's unreliable. We follow the symlink instead of
+                   executing the file directly in order to prevent top
+                   from displaying the name of the process as "exe". */
+                char runtime[PATH_MAX+1];
+                int i = readlink("/proc/self/exe", runtime, PATH_MAX);
+                if (i != -1) {
+                    runtime[i] = '\0';
+                    execve(runtime, argv, envp);
+                }
+            }
+            /* Either changing the personality or execve() failed.
+               Either way we might as well continue, and hope that
+               the random memory maps are ok this time around. */
+            {
+                char err_mess[] = "WARNING: Couldn't re-execute Poplog with"
+                            " the proper personality flags (maybe /proc"
+                            " isn't mounted?). Trying to continue anyway.\n";
+                write(2, err_mess, sizeof(err_mess)-1);
+            }
+        }
+    }
+#endif
+}
+#endif
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman and Waldek Hebisch 2 Dec 2008
+	Installed revisions posted by Waldek to poplog-dev on 2 Dec 2008
+	adding linux_setper, invoked from modified amain.s
+	Making invocation of setarch unnecessary
+--- Aaron Sloman and Waldek Hebisch 5 Jan 2007
+	Finally installed revisions posted by Waldek to poplog-dev on
+	3 April 2006
+	http://mailman.cs.bham.ac.uk/archives/poplog-dev/2006q2/000034.html
+
+--- Aaron Sloman and Waldek Hebisch 29 Jun 2003
+	The use of 'errno' which has been deprecated for some time is no longer
+	supported. So the old use is simulated using these two procedures defined
+	in $popexternlib/c_core.c (thanks to Waldek Hebisch):
+		int get_libc_errno(void)
+		int set_libc_errno(int x)
+
+	The are accessed via an active variable defined in $popsrc/errors.p
+	and its updater:
+
+		define active DO_ERRNO_VAL();
+
+		define updaterof active DO_ERRNO_VAL(_x);
+
+	$popsrc/unixdefs.ph was also changed:
+	This macro definition is no longer used
+		lconstant macro _ERRNO = [_extern errno:data!(int)];
+	Instead it is defined thus, to invoke the new active variable
+	or its updater:
+		lconstant macro _ERRNO = [DO_ERRNO_VAL];
+
+	This also required a change to LIB unix_socets
+	
 --- Robert Duncan, Feb 17 1999
 		Added an extra level of indirection to _WEAK_pop_external_callback
 		for HP-UX on PA-RISC.
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/extern/lib/mklibpop v15.6301-amd64/pop/extern/lib/mklibpop
--- pp0/v15.61-amd64/pop/extern/lib/mklibpop	2005-03-11 05:30:39.000000000 -0500
+++ v15.6301-amd64/pop/extern/lib/mklibpop	2009-12-24 15:25:18.000000000 -0500
@@ -80,8 +80,8 @@
 rm -f $LIB
 
 # compile files and create library
-echo $CC -c -O $CC_FLAGS -I$POP_X_INCLUDE *.c
-$CC -c -O $CC_FLAGS -I$POP_X_INCLUDE *.c && \
+echo $CC -c -g -O $CC_FLAGS -I$POP_X_INCLUDE *.c
+$CC -c -g -O $CC_FLAGS -I$POP_X_INCLUDE *.c && \
 $AR $LIB *.o && \
 $RANLIB
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lib/ved/ved_dired.p v15.6301-amd64/pop/lib/ved/ved_dired.p
--- pp0/v15.61-amd64/pop/lib/ved/ved_dired.p	1997-12-11 10:00:40.000000000 -0500
+++ v15.6301-amd64/pop/lib/ved/ved_dired.p	2008-06-20 12:24:32.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 1997.  All rights reserved. ---------
+/* --- Copyright University of Sussex 2008.  All rights reserved. ---------
  > File:           C.unix/lib/ved/ved_dired.p
  > Purpose:        EDIT a directory listing and obey commands
  > Author:         Aaron Sloman, Oct 1 1988 (see revisions)
@@ -331,6 +331,7 @@
 	dired_control(%false%)
 enddefine;
 
+/*
 ;;; ------------------------DEFAULT KEY SETTINGS  ???--------------------
 vedsetkey('\^X\^D',vedenter<>vedinsertstring(%default_command%));
 
@@ -343,10 +344,16 @@
 	ved_qdired();
 endprocedure);
 
+*/
+
 endsection;
 
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jun 20 2008
+		Commented out the suggested default key bindings as they cause
+		autoloading errors, and can interfere with other uses of ^X
+		in Ved
 --- John Williams, Dec 11 1997
 		dired -r and dired -w no longer give an error if executed when
 		cursor is on an empty line (BR joew.15).
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/arrays.p v15.6301-amd64/pop/lisp/src/arrays.p
--- pp0/v15.61-amd64/pop/lisp/src/arrays.p	1996-04-17 07:01:51.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/arrays.p	2009-12-30 17:03:00.000000000 -0500
@@ -545,8 +545,6 @@
 				;;; defaults
 				if len fi_< 16 then
 					16
-				elseif len fi_> 64 then
-					64
 				else
 					len
 				endif
@@ -758,10 +756,10 @@
 			lq1 fi_+ 1 -> lq1;
 			lq2 fi_+ 1 -> lq2;
 			lq3 fi_+ 1 -> lq3;
-			fast_apply(
+			fi_&&(fast_apply(
 				sub_s(lq1, v1),
 				sub_s(lq2, v2),
-				bit_op) -> sub_s(lq3, v3)
+				bit_op), 255) -> sub_s(lq3, v3)
 		endwhile;
 		returnif (hr1 == 0);    /* No bits left over */
 		lq1 fi_<< 3 fi_+ 1 -> lo1;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/chars.p v15.6301-amd64/pop/lisp/src/chars.p
--- pp0/v15.61-amd64/pop/lisp/src/chars.p	1995-08-07 11:59:05.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/chars.p	2009-12-27 00:32:50.000000000 -0500
@@ -106,7 +106,9 @@
 /* Character conversions */
 
 define character(item);
-	if isintegral(item) then
+        if ischaracter(item) then
+                item
+	elseif isintegral(item) then
 		conscharacter(item)
 	else
 		get_simple_string(item) -> item;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/equals.p v15.6301-amd64/pop/lisp/src/equals.p
--- pp0/v15.61-amd64/pop/lisp/src/equals.p	1995-08-08 06:50:25.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/equals.p	2009-12-27 00:32:39.000000000 -0500
@@ -194,13 +194,13 @@
 	returnunless ((hi1 fi_- lo1) == (hi2 fi_- lo2)) (false);
 
 	unless b1 do
-		lo1 -> fast_front(Temp_b1);
-		hi1 -> fast_front(Temp_b1_back);
+		0 -> fast_front(Temp_b1);
+		hi1 fi_- lo1 -> fast_front(Temp_b1_back);
 		Temp_b1 -> b1
 	endunless;
 	unless b2 do
-		lo2 -> fast_front(Temp_b2);
-		hi2 -> fast_front(Temp_b2_back);
+		0 -> fast_front(Temp_b2);
+		hi2 fi_- lo2 -> fast_front(Temp_b2_back);
 		Temp_b2 -> b2
 	endunless;
 	returnunless (sys_=(b1, b2)) (false);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/exporti.p v15.6301-amd64/pop/lisp/src/exporti.p
--- pp0/v15.61-amd64/pop/lisp/src/exporti.p	1996-01-17 11:21:53.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/exporti.p	2009-12-30 18:38:17.000000000 -0500
@@ -95,7 +95,7 @@
 Exporti(@SECOND,                inline_cadr,                    false);
 Exporti(@SEVENTH,               inline_nth(% 7, pair_key %),    false);
 Exporti(@SIXTH,                 inline_nth(% 6, pair_key %),    false);
-Exporti(@SVREF,                 inline_svref,                   false);
+;;; Exporti(@SVREF,                 inline_svref,                   false);
 Exporti(@TENTH,                 inline_nth(% 10, pair_key %),   false);
 Exporti(@THIRD,                 inline_nth(% 3, pair_key %),    false);
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/exports v15.6301-amd64/pop/lisp/src/exports
--- pp0/v15.61-amd64/pop/lisp/src/exports	1999-08-27 09:01:57.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/exports	2009-12-30 00:04:57.000000000 -0500
@@ -297,7 +297,7 @@
 @GET-DECODED-TIME,               get_decoded_time,                [0 0 9]
 @GET-DISPATCH-MACRO-CHARACTER,   get_dmac_char,                   [2 3 1]
 @GET-INTERNAL-REAL-TIME,         get_internal_real_time,          [0 0 1]
-@GET-INTERNAL-RUN-TIME,          systime,                         [0 0 1]
+@GET-INTERNAL-RUN-TIME,          get_internal_run_time,           [0 0 1]
 @GET-MACRO-CHARACTER,            get_macro_char,                  [1 2 2]
 @GET-OUTPUT-STREAM-STRING,       get_stringout_string,            []
 @GET-PROPERTIES,                 get_properties,                  []
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/hash.p v15.6301-amd64/pop/lisp/src/hash.p
--- pp0/v15.61-amd64/pop/lisp/src/hash.p	1995-11-29 10:19:25.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/hash.p	2009-12-30 16:15:01.000000000 -0500
@@ -19,7 +19,8 @@
 	dlocal pop_hash_lim;
 
 	#_< syshash(pair_key) >_#;      ;;; Running total kept on stack
-	while ispair(l) do
+	if pop_hash_lim /== 0 then
+	    while ispair(l) do
 		pop_hash_lim fi_- 1 -> pop_hash_lim;
 		fast_apply(fast_destpair(l) -> l, hash_p);
 		unless isinteger(dup()) do
@@ -27,9 +28,10 @@
 		endunless;
 		nonop fi_+ ();
 		returnif(pop_hash_lim == 0);
-	endwhile;
-	if l /== [] then
+	    endwhile;
+	    if l /== [] then
 		fi_+ fast_apply(l, hash_p)
+	    endif
 	endif
 enddefine;
 
@@ -176,7 +178,7 @@
 
 	/* Convert rehash size to power of two */
 	if rehash_size == nil then
-		false
+		1
 	elseif (isinteger(rehash_size) and rehash_size fi_> 0) then
 		1
 	elseif (isdecimal(rehash_size) and rehash_size > 1) then
@@ -194,7 +196,7 @@
 
 	/* Convert rehash threshold (occupancy ratio) into number of entries */
 	if rehash_threshold == nil then
-		false
+		round(size * 0.7)
 	else
 		unless isreal(rehash_threshold)
 		and rehash_threshold >= 0
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/inlines.p v15.6301-amd64/pop/lisp/src/inlines.p
--- pp0/v15.61-amd64/pop/lisp/src/inlines.p	1996-01-17 11:20:50.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/inlines.p	2009-12-30 18:35:25.000000000 -0500
@@ -356,7 +356,7 @@
 	inline_rplaca   =   Inline_any(% fast_rplaca, 2 %),
 	inline_rplacd   =   Inline_any(% fast_rplacd, 2 %),
 	inline_schar    =   Inline_any(% fast_schar, 2 %),
-	inline_svref    =   Inline_any(% fast_subscrv0, 2 %), /* see note below */
+;;;	inline_svref    =   Inline_any(% fast_subscrv0, 2 %), /* see note below */
 	inline_char_code=   Inline_any(% fast_char_code, 1 %),
 	inline_code_char=   Inline_any(% fast_code_char, 1 %),
 	inline_char_int =   Inline_any(% fast_char_code, 1 %),
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/itemise.p v15.6301-amd64/pop/lisp/src/itemise.p
--- pp0/v15.61-amd64/pop/lisp/src/itemise.p	1995-08-25 10:56:52.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/itemise.p	2009-12-27 00:31:54.000000000 -0500
@@ -124,17 +124,6 @@
 enddefine;
 
 
-define skipform();
-	;;; used when *READ-SUPPRESS* is true
-	if is_char_mac(lextype) then
-		lextype()
-	else
-		until (lexget(), AT_TOKEN_END) do enduntil, lexput();
-		nil
-	endif
-enddefine;
-
-
 define digit();
 	lvars n;
 	lexchar;
@@ -263,12 +252,32 @@
 			true -> lex_eof_error;          ;;; force an error
 			eof()
 		endif;
-		lexchar
+                if read_suppress == nil then
+		    lexchar
+                endif
 	enduntil;
 	false ->> lex_redo -> lexnum
 enddefine;
 
 
+define skipform();
+	;;; used when *READ-SUPPRESS* is true
+	if is_char_mac(lextype) then
+		lextype()
+	else
+		repeat
+                   if lextype == multiple_escape then
+                       multiple_escape()
+                   elseif lextype == single_escape then
+                       lexget()
+                   endif;
+                   lexget();
+                   quitif(AT_TOKEN_END);
+                endrepeat, lexput();
+		nil
+	endif
+enddefine;
+
 define colon();
 	lvars pkg;
 	if lexpkg then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/print.p v15.6301-amd64/pop/lisp/src/print.p
--- pp0/v15.61-amd64/pop/lisp/src/print.p	1995-11-29 10:21:19.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/print.p	2009-12-26 19:31:24.000000000 -0500
@@ -355,7 +355,13 @@
 
 define lconstant Escape_pr(s);
 	cucharout(`|`);
-	appdata(s, cucharout);
+	appdata(s, 
+                procedure(c);
+                    if c = `\\` or c = `|` then
+                        cucharout(`\\`);
+                    endif;
+                    cucharout(c);
+                endprocedure);
 	cucharout(`|`);
 enddefine;
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/specs.p v15.6301-amd64/pop/lisp/src/specs.p
--- pp0/v15.61-amd64/pop/lisp/src/specs.p	1995-08-07 10:15:53.000000000 -0400
+++ v15.6301-amd64/pop/lisp/src/specs.p	2009-12-30 21:34:48.000000000 -0500
@@ -8,15 +8,20 @@
 
 lisp_compile_mode;
 
+#include sysdefs.ph
+
 section $-lisp;
 
 /* Field spec <-> element type conversions */
 
 lconstant Word_spec_to_int
-	= newproperty([[uint     32]
+	= newproperty([
+                                   [ulong    64]
+                                   [long    -64]
+                                   [uint     32]
 				   [int     -32]
-				   [ulong    32]
-				   [long    -32]
+				   [uint    32]
+				  ;;;  [long    -32]
 				   [pint    -30]
 				   [ushort   16]
 				   [short   -16]
@@ -25,8 +30,11 @@
 
 
 lconstant Int_spec_to_word
-	= newproperty([[-32     long]
-				   [32      ulong]
+	= newproperty([
+                                   [64    ulong]
+                                   [-64    long]
+                                   [-32     int]
+				   [32      uint]
 				   [-30     pint]
 				   [-16     short]
 				   [16      ushort]
@@ -133,17 +141,32 @@
 /* Key <-> spec/element-type conversions */
 
 lconstant Spec_to_key
-	= newproperty([[1           ^bitvector_key]
-				   [character   ^string_key]
-				   [short       ^shortvec_key]
-				   [int         ^intvec_key]
-				   [long        ^intvec_key]
-				   [full        ^vector_key]], 31, false, true);
+    = newproperty([[1           ^bitvector_key]
+                   [character   ^string_key]
+                   [byte        ^bytevec_key]
+                   [sbyte       ^sbytevec_key]
+                   [ushort      ^ushortvec_key]
+                   [short       ^shortvec_key]
+                   [uint        ^untvec_key]
+                   [int         ^intvec_key]
+                   [ulong       ^ulongvec_key]
+                   [long        ^longvec_key]
+                   [full        ^vector_key]], 31, false, true);
 
 
 define spec_->_key(spec) -> key;
-	if isintegral(spec) and abs(spec) > 32 then
-		"full" -> spec
+	if isintegral(spec) then
+            if abs(spec) > 64 then
+		"full"
+            elseif abs(spec) > 32 then
+               if spec > 0 then "ulong" else "long" endif;
+            elseif abs(spec) > 16 then
+               if spec > 0 then "uint" else "int" endif;
+            elseif abs(spec) > 8 then
+               if spec > 0 then "ushort" else "short" endif;
+            elseif abs(spec) > 1 then
+               if spec > 0 then "byte" else "sbyte" endif;
+            else spec endif -> spec;
 	elseif spec == "decimal" then
 		"sfloat" -> spec
 	elseif spec == "ddecimal" then
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/lisp/src/time.p v15.6301-amd64/pop/lisp/src/time.p
--- pp0/v15.61-amd64/pop/lisp/src/time.p	1995-11-29 10:21:51.000000000 -0500
+++ v15.6301-amd64/pop/lisp/src/time.p	2009-12-30 08:24:25.000000000 -0500
@@ -11,7 +11,7 @@
 section $-lisp;
 
 
-constant internal_time_units_per_sec = 100;
+constant internal_time_units_per_sec = 1000000;
 
 constant _1900_1970 = 70 * 365 * 86400 /* 17 leap years */ + (17 * 86400);
 
@@ -20,9 +20,12 @@
 	sys_real_time() + _1900_1970
 enddefine;
 
+define get_internal_run_time();
+    systime()*10000 ;;; internal_time_units_per_sec/100
+enddefine;
 
 define get_internal_real_time();
-	sys_real_time() * internal_time_units_per_sec
+    sys_microtime()
 enddefine;
 
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/com/poplogout.sh v15.6301-amd64/pop/packages/com/poplogout.sh
--- pp0/v15.61-amd64/pop/packages/com/poplogout.sh	2001-08-23 18:35:02.000000000 -0400
+++ v15.6301-amd64/pop/packages/com/poplogout.sh	2009-07-16 16:26:06.000000000 -0400
@@ -1,9 +1,11 @@
-#!/bin/csh
+#!/bin/bash
 # J. Meyer, Nov 1990
+# Modified A.Sloman for bash 16 Jul 2009
 # poplogout - remove Poplog from environment
 # usage: source poplogout
 
-if ( ! ($?usepop || $?popsys )) exit 0 # no poplog to logout from
+if [ ! ${usepop} ]; then exit 0 ; fi
+# no poplog to logout from
 
 # print a brief message
 echo "poplogout":  poplog, usepop = $usepop
@@ -12,7 +14,7 @@
 # BASIC UNSETS: remove variables listed in $usepop/pop/com/popenv
 # And others added by A.Sloman
 
-foreach i ( \
+for i  in \
         popcom \
         popsrc \
         popsys \
@@ -42,24 +44,26 @@
         pop_xved     \
         pop_xvedpro  \
         pop_xvedlisp \
-    )
-    unsetenv $i
-end
-
-# UNSET PATH: remove $usepop and $poplocal from path
-set npath=
-foreach i ( $path )
-if (("$i" !~ "$usepop"*) && ("$i" !~ "$poplocal"*) ) set npath=($npath $i)
-end
-set path=($npath)
-unset npath
-
-# TESTED UNSETS: unset conditionally set variables
-if ("$poplocal" == "$usepop/pop") unsetenv poplocal
-if ("$popcontrib" == "$usepop/pop/contrib") unsetenv popcontrib
-if ("$poplib" == "$HOME") unsetenv poplib
-if ($?pop_pop11) unsetenv pop_pop11
-# UNSET USEPOP
-unsetenv usepop
+    ;
+do
+    ## echo $i
+    unset $i
+done
+
+## # UNSET PATH: remove $usepop and $poplocal from path
+## set npath=
+## foreach i ( $path )
+## if (("$i" !~ "$usepop"*) && ("$i" !~ "$poplocal"*) ) set npath=($npath $i)
+## end
+## set path=($npath)
+## unset npath
+##
+## # TESTED UNSETS: unset conditionally set variables
+## if ("$poplocal" == "$usepop/pop") unsetenv poplocal
+## if ("$popcontrib" == "$usepop/pop/contrib") unsetenv popcontrib
+## if ("$poplib" == "$HOME") unsetenv poplib
+## if ($?pop_pop11) unsetenv pop_pop11
+## # UNSET USEPOP
+unset usepop
 
 # DONE
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/popvision/lib/Xcolour_to_rgb.p v15.6301-amd64/pop/packages/popvision/lib/Xcolour_to_rgb.p
--- pp0/v15.61-amd64/pop/packages/popvision/lib/Xcolour_to_rgb.p	1999-09-24 05:18:18.000000000 -0400
+++ v15.6301-amd64/pop/packages/popvision/lib/Xcolour_to_rgb.p	2009-02-19 20:33:39.000000000 -0500
@@ -1,4 +1,5 @@
-/* --- Copyright University of Sussex 1999. All rights reserved. ----------
+/* --- Copyright University of Sussex 2009. All rights reserved. ----------
+	--- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:            $popvision/lib/Xcolour_to_rgb.p
  > Purpose:         Get r, g, b components of X colour specifications
  > Author:          David S Young, Feb 20 1994 (see revisions)
@@ -11,6 +12,7 @@
 section;
 
 vars Xcolour_to_rgb_filelist = [
+	'/usr/share/X11/rgb.txt'
     '/usr/lib/X11/rgb.txt'
     '$Xroot/lib/X11/rgb.txt'
     '/usr/openwin/lib/rgb.txt'
@@ -110,6 +112,9 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, 20 Feb 2009
+		Added '/usr/share/X11/rgb.txt' to
+		Xcolour_to_rgb_*filelist
 --- David Young, Sep 24 1999
         Added Anthony Worrall's modification for iris to readcolours
         (looks like it allows space-separated numbers in colour names)
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/popvision/lib/sunrasterfile.p v15.6301-amd64/pop/packages/popvision/lib/sunrasterfile.p
--- pp0/v15.61-amd64/pop/packages/popvision/lib/sunrasterfile.p	2004-12-06 17:02:41.000000000 -0500
+++ v15.6301-amd64/pop/packages/popvision/lib/sunrasterfile.p	2009-02-20 23:00:06.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2004. All rights reserved. ----------
+/* --- Copyright University of Sussex 2009. All rights reserved. ----------
  > File:            $popvision/lib/sunrasterfile.p
  > File:            $poplocal/local/popvision/lib/sunrasterfile.p
  > Purpose:         Read and write Sun rasterfiles
@@ -16,14 +16,14 @@
 /* Rasterfile constants from /usr/include/rasterfile.h */
 
 defclass lconstant rasterfile {
-    >-> ras_magic       :int,       /* magic number */
-        ras_width       :int,       /* width (pixels) of image */
-        ras_height      :int,       /* height (pixels) of image */
-        ras_depth       :int,       /* depth (1, 8, or 24 bits) of pixel */
-        ras_length      :int,       /* length (bytes) of image */
-        ras_type        :int,       /* type of file; see RT_* below */
-        ras_maptype     :int,       /* type of colormap; see RMT_* below */
-        ras_maplength   :int        /* length (bytes) of following map */
+    >-> ras_magic       :uint,       /* magic number */
+        ras_width       :uint,       /* width (pixels) of image */
+        ras_height      :uint,       /* height (pixels) of image */
+        ras_depth       :uint,       /* depth (1, 8, or 24 bits) of pixel */
+        ras_length      :uint,       /* length (bytes) of image */
+        ras_type        :uint,       /* type of file; see RT_* below */
+        ras_maptype     :uint,       /* type of colormap; see RMT_* below */
+        ras_maplength   :uint        /* length (bytes) of following map */
     /* color map follows for ras_maplength bytes, followed by image */
 };
 
@@ -373,6 +373,20 @@
     endunless;
 enddefine;
 
+;;; Hackish method to convert from little-endian int to big-endian int if
+;;; on little-endian platform. Needed to write the headers correctly.
+define lconstant to_bigendian(integer) -> big_endian;
+    #_IF (fsub_b(1, consintvec(1,1)) /== 0)
+       lvars result = 0;
+       result + ( ( integer && 16:FF000000 ) >> 24) -> result;
+       result + ( ( integer && 16:00FF0000 ) >> 8 ) -> result;
+       result + ( ( integer && 16:0000FF00 ) << 8 ) -> result;
+       result + ( ( integer && 16:000000FF ) << 24) -> result;
+       result -> big_endian;
+    #_ELSE
+        integer -> big_endian;
+    #_ENDIF;
+enddefine;
 
 define sunrasterfile(filename) /* -> (array, [cmap])*/;
     lvars return_cmap = false, tag = false, array, cmap;
@@ -533,6 +547,7 @@
 
 define updaterof sunrasterfile(array, filename);
     lvars array, cmap = false, filename;
+    lvars cmap_type, cmap_length; ;;; Calculated later on
     if array.isvector then
         ;;; There is a colour map argument.
         (array, filename) -> (array, cmap, filename)
@@ -570,32 +585,36 @@
         mishap(datakey(data), 1, 'Illegal type of array for rasterfile')
     endunless;
 
-    ;;; Set up header
-    RAS_MAGIC -> rasheader.ras_magic;
-    wid -> rasheader.ras_width;
-    ht -> rasheader.ras_height;
-    dep -> rasheader.ras_depth;
-    len -> rasheader.ras_length;
-    RT_STANDARD -> rasheader.ras_type;
-
     ;;; Deal with colour map
     if cmap then
-        RMT_EQUAL_RGB -> rasheader.ras_maptype;
-        length(cmap(1)) * NRGB -> rasheader.ras_maplength;
+        RMT_EQUAL_RGB -> cmap_type;
+        length(cmap(1)) * NRGB -> cmap_length;
         cmap_vec_to_buff(cmap) -> cmap;
     elseif dep == 1 or dep == 24 then
-        RMT_NONE -> rasheader.ras_maptype;
-        0 -> rasheader.ras_maplength
+        RMT_NONE -> cmap_type;
+        0 -> cmap_length
     else
-        RMT_EQUAL_RGB -> rasheader.ras_maptype;
-        NRGB * cmap_max -> rasheader.ras_maplength;
+        RMT_EQUAL_RGB -> cmap_type;
+        NRGB * cmap_max -> cmap_length;
         cmap_default -> cmap;
     endif;
 
+    ;;; Set up header
+    ;;; Hack: On little-endian machines the fields will need to be reversed.
+    ;;; Calling to_bigendian(int) does this if it needs to be done.
+    to_bigendian(RAS_MAGIC) -> rasheader.ras_magic;
+    to_bigendian(wid) -> rasheader.ras_width;
+    to_bigendian(ht) -> rasheader.ras_height;
+    to_bigendian(dep) -> rasheader.ras_depth;
+    to_bigendian(len) -> rasheader.ras_length;
+    to_bigendian(RT_STANDARD) -> rasheader.ras_type;
+    to_bigendian(cmap_type) -> rasheader.ras_maptype;
+    to_bigendian(cmap_length) -> rasheader.ras_maplength;
+
     ;;; Write header and colour map
     syswrite(dev, rasheader, rasheadbytes);
     if cmap then
-        syswrite(dev, cmap, rasheader.ras_maplength)
+        syswrite(dev, cmap, cmap_length)
     endif;
 
     ;;; Write the data itself.
@@ -621,6 +640,16 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Feb 21 2009
+	Modified to avoid repeatedly checking for endianness
+
+--- Aaron Sloman, Feb 20 2009
+	Installed Jack Hollingworth's fix for updater of sunrasterfile
+	for use on little-endian machines.
+
+--- Jack Hollingworth (Reading University), Feb 17 2009
+    Fixed writing of file header on little-endian machines
+
 --- Aaron Sloman, Dec  6 2004
 	For linux set the default value of -sunrasterfile_converter-
 	to "convert"
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/rclib/auto/ved_rcdemo.p v15.6301-amd64/pop/packages/rclib/auto/ved_rcdemo.p
--- pp0/v15.61-amd64/pop/packages/rclib/auto/ved_rcdemo.p	1997-03-30 15:20:15.000000000 -0500
+++ v15.6301-amd64/pop/packages/rclib/auto/ved_rcdemo.p	2009-07-03 21:11:37.000000000 -0400
@@ -1,8 +1,8 @@
-/* --- Copyright University of Birmingham 1997. All rights reserved. ------
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
  > File:            $poplocal/local/rclib/auto/ved_rcdemo.p
  > Purpose:         Accessing demonstration programs in the
 					RCLIB demo library
- > Author:          Aaron Sloman, Mar 30 1997
+ > Author:          Aaron Sloman, Mar 30 1997 (see revisions)
  > Documentation:
  > Related Files:
  */
@@ -15,7 +15,14 @@
 		vedargument sys_>< '.p' -> vedargument
 	endunless;
 
-	veddo('pved $poplocal/local/rclib/demo/' dir_>< vedargument)
+;;;	veddo('pved $poplocal/local/rclib/demo/' dir_>< vedargument)
+	veddo('pved ' >< poprclibdir dir_>< 'demo' dir_>< vedargument)
 enddefine;
 
+
 endsection;
+
+/* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul  4 2009
+		Changed to use poprclibdir
+ */
